; Source created with Parsic Version 3.x

; at              : 08/01/03 10.44.14


; Project File    : C:\PROGRA~1\PARSIC\VARI\JKMSFL.PIC

; Project Version : 1.0.23

; Created         : 14/06/99 20.16.00

; Last change     : 08/01/03 10.44.07

	PROCESSOR 16F84

	INCLUDE P16F84.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_ON & _XT_OSC

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

S0	= 12	; located in Bank 0, 1
S1	= 13	; located in Bank 0, 1
RAM	= 14	; located in Bank 0, 1

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP
	RETURN

;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00000000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW 15
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG


; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'11111111'
	MOVWF TRISB

; init vars


; Clear RAM

	MOVLW 12
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	MOVFW FSR
	SUBLW 80
	BTFSS STATUS,ZERO
	GOTO CR1

	MOVLW B'11011111'
	MOVWF S0
	MOVLW B'00000011'
	MOVWF S1


;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; UND - Gatter -> UG1
;***************************************************

LABEL_UG1_1
	BTFSS S1,0
	GOTO LABEL_UG1_FALSE
LABEL_UG1_2
	BTFSS S0,5
	GOTO LABEL_UG1_FALSE
LABEL_UG1_3
	BTFSS S1,2
	GOTO LABEL_UG1_FALSE

LABEL_UG1_TRUE
	BCF S0,1
	GOTO LABEL_UG1_ENDE
LABEL_UG1_FALSE
	BSF S0,1
LABEL_UG1_ENDE
;***************************************************
; UND - Gatter -> UG2
;***************************************************

LABEL_UG2_1
	BTFSS S1,3
	GOTO LABEL_UG2_FALSE
LABEL_UG2_2
	BTFSS S0,5
	GOTO LABEL_UG2_FALSE
LABEL_UG2_3
	BTFSS S1,1
	GOTO LABEL_UG2_FALSE

LABEL_UG2_TRUE
	BCF S0,0
	GOTO LABEL_UG2_ENDE
LABEL_UG2_FALSE
	BSF S0,0
LABEL_UG2_ENDE
;***************************************************
; UND - Gatter -> UG3
;***************************************************

LABEL_UG3_1
	BTFSS S0,1
	GOTO LABEL_UG3_FALSE
LABEL_UG3_2
	BTFSS S0,2
	GOTO LABEL_UG3_FALSE

LABEL_UG3_TRUE
	BCF S0,3
	GOTO LABEL_UG3_ENDE
LABEL_UG3_FALSE
	BSF S0,3
LABEL_UG3_ENDE
;***************************************************
; UND - Gatter -> UG4
;***************************************************

LABEL_UG4_1
	BTFSS S0,3
	GOTO LABEL_UG4_FALSE
LABEL_UG4_2
	BTFSS S0,0
	GOTO LABEL_UG4_FALSE

LABEL_UG4_TRUE
	BCF S0,2
	GOTO LABEL_UG4_ENDE
LABEL_UG4_FALSE
	BSF S0,2
LABEL_UG4_ENDE
;***************************************************
; UND - Gatter -> UG5
;***************************************************

LABEL_UG5_1
	BTFSS S0,4
	GOTO LABEL_UG5_FALSE
LABEL_UG5_2
	BTFSS S0,3
	GOTO LABEL_UG5_FALSE

LABEL_UG5_TRUE
	BCF S0,6
	GOTO LABEL_UG5_ENDE
LABEL_UG5_FALSE
	BSF S0,6
LABEL_UG5_ENDE
;***************************************************
; UND - Gatter -> UG6
;***************************************************

LABEL_UG6_1
	BTFSS S0,2
	GOTO LABEL_UG6_FALSE
LABEL_UG6_2
	BTFSS S0,4
	GOTO LABEL_UG6_FALSE

LABEL_UG6_TRUE
	BCF S0,7
	GOTO LABEL_UG6_ENDE
LABEL_UG6_FALSE
	BSF S0,7
LABEL_UG6_ENDE
;***************************************************
; UND - Gatter -> UG7
;***************************************************

LABEL_UG7_1
	BTFSS S0,6
	GOTO LABEL_UG7_FALSE
LABEL_UG7_2
	BTFSS S1,0
	GOTO LABEL_UG7_FALSE

LABEL_UG7_TRUE
	BCF S1,1
	GOTO LABEL_UG7_ENDE
LABEL_UG7_FALSE
	BSF S1,1
LABEL_UG7_ENDE
;***************************************************
; UND - Gatter -> UG8
;***************************************************

LABEL_UG8_1
	BTFSS S1,1
	GOTO LABEL_UG8_FALSE
LABEL_UG8_2
	BTFSS S0,7
	GOTO LABEL_UG8_FALSE

LABEL_UG8_TRUE
	BCF S1,0
	GOTO LABEL_UG8_ENDE
LABEL_UG8_FALSE
	BSF S1,0
LABEL_UG8_ENDE
;***************************************************
; UND - Gatter -> UG9
;***************************************************

LABEL_UG9_1
	BTFSS S0,5
	GOTO LABEL_UG9_FALSE

LABEL_UG9_TRUE
	BCF S0,4
	GOTO LABEL_UG9_ENDE
LABEL_UG9_FALSE
	BSF S0,4
LABEL_UG9_ENDE
;****************************************

	GOTO MAIN


	END

